/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by 
 *  Björnsen Beratende Ingenieure GmbH 
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.client.client.ui;

import org.dive4elements.river.client.client.ui.DatacageTwinPanel.IDatacageTwinPanelInfo;
import org.dive4elements.river.client.shared.model.Recommendation;

/**
 * An info implementation that does NOT tweak any factories.
 * 
 * @author Gernot Belger
 */
public final class NilDatacageTwinPanelInfo implements IDatacageTwinPanelInfo {

	private final String outs;

	public NilDatacageTwinPanelInfo(final String outs) {
		this.outs = outs;
	}
	
	@Override
	public String getFactory(final String originalFactory) {
	    return originalFactory;
	}

	
	@Override
	public String getDataStringFactory(final Recommendation recommendation) {
		return recommendation.getFactory();
	}

    @Override
	public void adjustRecommendation(final Recommendation recommendation) {
        /* does nothing */
    }

	@Override
	public String getOuts() {
		return this.outs;
	}
}